--- cli.c.orig	2004-07-04 03:03:44.000000000 -0400
+++ cli.c	2004-07-04 14:08:33.000000000 -0400
@@ -25,6 +25,7 @@
 #include <stdio.h>
 #include <signal.h>
 #include <string.h>
+#include <errno.h>
 /* For rl_filename_completion */
 #include "editline/readline/readline.h"
 /* For module directory */
@@ -37,12 +38,18 @@
 	
 void ast_cli(int fd, char *fmt, ...)
 {
+	int res;
+	int wrote = 0;
 	char *stuff;
 	va_list ap;
 	va_start(ap, fmt);
 	vasprintf(&stuff, fmt, ap);
 	va_end(ap);
-	write(fd, stuff, strlen(stuff));
+	do {
+		res = write(fd, stuff, strlen(stuff) - wrote);
+		if (res != -1) wrote += res;
+	} while ((res == -1 && errno == EAGAIN) || (res != wrote && res != -1) );
+
 	free(stuff);
 }
 
